// Copyright 2005-2006, FreeHEP.
package hep.wired.heprep.interaction;

import hep.wired.heprep.graphicspanel.ControlPanel;
import hep.wired.heprep.plugin.WiredPlugin;
import hep.wired.image.WiredBaseImage;
import hep.wired.interaction.DragAngledRectangleToScale;
import hep.wired.interaction.DragBallToRotate;
import hep.wired.interaction.DragRectangleToScale;
import hep.wired.interaction.DragToRotate;
import hep.wired.interaction.DragToTranslate;
import hep.wired.services.InteractionHandler;

import javax.swing.Icon;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: Interaction.java 13827 2011-05-05 03:08:47Z onoprien $
 */
public class Interaction extends RoutingInteractionHandler {

    private static Interaction instance;

    private InteractionPanel panel;

    private Interaction() {
        super("Interaction");

        panel = new InteractionPanel();

        // Scaling
        InteractionHandler dragToScale = WiredPlugin.IH.ZOOM_DRAG.get();
//        InteractionHandler dragToScale = new DragToScale();
        add(dragToScale, true);
        panel.addInteraction(dragToScale, true);

        // FIXME, NPE when this is not called.
        panel.setInteractionHandler(dragToScale);

        InteractionHandler dragRectangleToScale = WiredPlugin.IH.ZOOM_RECTANGLE.get();
//        InteractionHandler dragRectangleToScale = new DragRectangleToScale();
        add(dragRectangleToScale, false);
        panel.addInteraction(dragRectangleToScale, false);

        InteractionHandler dragAngledRectangleToScale = WiredPlugin.IH.ZOOM_ANGLE.get();
//        InteractionHandler dragAngledRectangleToScale = new DragAngledRectangleToScale();
        add(dragAngledRectangleToScale, false);
        panel.addInteraction(dragAngledRectangleToScale, false);

        // Rotation
        InteractionHandler dragBallToRotate = WiredPlugin.IH.ROTATE_BALL.get();
//        InteractionHandler dragBallToRotate = new DragBallToRotate();
        add(dragBallToRotate, false);
        panel.addInteraction(dragBallToRotate, false);

        InteractionHandler dragToRotate = WiredPlugin.IH.ROTATE_FLAT.get();
//        InteractionHandler dragToRotate = new DragToRotate();
        add(dragToRotate, false);
        panel.addInteraction(dragToRotate, false);

        // Translation
        InteractionHandler dragToTranslate = WiredPlugin.IH.TRANSLATE.get();
//        InteractionHandler dragToTranslate = new DragToTranslate();
        add(dragToTranslate, false);
        panel.addInteraction(dragToTranslate, false);

        // Measurement
        InteractionHandler dragToMeasure = WiredPlugin.IH.MEASURE.get();
//        InteractionHandler dragToMeasure = new DragToMeasure();
        add(dragToMeasure, false);
        panel.addInteraction(dragToMeasure, false);

        panel.addInteraction(null, false);
    }

    public static Interaction getInstance() {
        if (instance == null) {
            instance = new Interaction();
        }
        return instance;
    }

    public ControlPanel getPanel() {
        return panel;
    }

    public Icon getIcon(int size) {
        return WiredBaseImage.getIcon("Scale%w", size);
    }

    public String getDescription() {
        return "General Interaction.";
    }

    public String toString() {
        return "Interaction";
    }
}
