// Copyright 2005, FreeHEP.
package hep.wired.heprep.standalone;

import hep.graphics.heprep.HepRep;
import hep.graphics.heprep.HepRepReader;
import hep.graphics.heprep.xml.XMLHepRepFactory;
import hep.wired.heprep.graphicspanel.HepRepGraphicsMode;
import hep.wired.heprep.graphicspanel.HepRepPanel;
import hep.wired.plot.WiredPlot;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import javax.swing.JFrame;

/**
 * Example to run WIRED stand-alone Should move to "standalone" package
 * 
 * @author Mark Donszelmann
 * @version $Id: Wired.java 8598 2006-08-14 20:38:02Z duns $
 */

public class Wired {

    public static void main(String[] args) throws Exception {
        if (args.length < 1) {
            System.err.println("Usage: Wired heprepfile");
            System.exit(1);
        }

        File file = new File(args[0]);
        System.out.println("Open HepRep file " + file.getName() + "...");

        XMLHepRepFactory factory = new XMLHepRepFactory();
        InputStream in = new FileInputStream(file);
        if (file.getName().toLowerCase().indexOf(".bheprep") >= 0) {
            in = new DataInputStream(in);
        }
        HepRepReader reader = factory.createHepRepReader(in);
        HepRep heprep = reader.next();
        reader.close();

        System.out.println("Opening WIRED4...");

        WiredPlot plot = new WiredPlot("WIRED 4", new HepRepPanel(
                new HepRepGraphicsMode(false)));
        JFrame frame = new JFrame("WIRED 4");
        frame.getContentPane().add(plot);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);

        System.out.println("Displaying Event...");
        plot.setRecord(heprep);
    }
}
